// Viewer

import java.awt.*;

abstract public class Viewer extends Canvas {
	protected CBNapplet applet;
	
	public Viewer (CBNapplet applet) {
		this.applet = applet;
	}
	
	abstract public void initialize (boolean color, int numColors);
	abstract public void update (int x, int y, int color);
	abstract public void updateLine (int x, int y, int x1, int y1, int color);
	abstract public void freeResources();
}
